import pygame

class Drawable(object):
    def __init__(self, draw_pos):
        self.draw_pos = draw_pos
        self.ignore_viewport = False

    def apply_viewport(self, viewport):
        if self.ignore_viewport:
            return
        #self.draw_pos.center = self.pos.center
        self.draw_pos.x -= viewport.x
        self.draw_pos.y -= viewport.y

    def draw(self, screen, viewport):
        #self.apply_viewport(viewport)

        #subclass should implement
        pass

class DebugDraw(Drawable):
    def __init__(self, draw_pos, color = pygame.Color(255, 0, 255, 127)):
        Drawable.__init__(self, draw_pos)
        self.color = color

    def draw(self, screen, viewport):
        import pygame.gfxdraw
        pygame.gfxdraw.box(screen, self.draw_pos, self.color)

