import os
import data
#import pygame.mixer.music as music
from pygame.mixer import music
import pygame
import pygame.locals as pgl
import random

MUSIC_END_EVENT = pgl.USEREVENT + 1

class Music(object):
    instance = None

    def __init__(self):
        Music.instance = self
        pygame.mixer.init()
        self.songs = [
                "silence.ogg",
                "Alexander_Ehlers_-_Twists.ogg",
                "silence.ogg",
                "Alexander_Ehlers_-_Doomed.ogg",
                ]
        self.songs = [data.filepath(os.path.join("music", x)) for x in self.songs]
        self.songlist = self.songs[:]
        #random.shuffle(self.songlist)

        self.current_song = -1
        self.count = len(self.songs)


    def play(self):
        if music.get_busy():
            return
        music.set_endevent(MUSIC_END_EVENT)
        self.current_song += 1
        if self.current_song == self.count:
            self.current_song = 0
            #random.shuffle(self.songlist)
        song = self.songlist[self.current_song]
        #print song
        music.load(song)
        music.play()
        music.set_volume(0.21)

    def stop(self):
        self.music.set_endevent()
        music.stop()

    def fadeout(self):
        music.fadeout(100)

    def set_end_event(self, event):
        music.set_endevent(event)

    def handle_event(self, event):
        self.play()

    def next(self):
        self.fadeout()
        self.play()

    @staticmethod
    def get_instance():
        if not Music.instance:
            raise RuntimeError('Requested instance before initialisation')
        return Music.instance

